//=============================================================================
//
// file :        Daresbury.h
//
// description : Include for the Daresbury class.
//
// project :	Daresbury Tango Class
//
// $Author: jlpons $
//
// $Revision: 1.1 $
//
// $Log: not supported by cvs2svn $
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _DARESBURY_H
#define _DARESBURY_H


#include <tango.h>
//using namespace Tango;

/**
 * @author	$Author: jlpons $
 * @version	$Revision: 1.1 $ $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------
#define MAX_MODS 22
#define MAX_LOG  30

typedef struct {
  long  log_time;
  short itlk[MAX_MODS];
} ItlkLog;

namespace Daresbury
{

/**
 * Class Description:
 * A class to handle the ESRF PSS interlock system
 *	(Hardware design has been done first by Daresbury Laboratory and
 *	redone by ESRF later
 */

/*
 *	Device States Description:
 */


class Daresbury: public Tango::Device_2Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevShort	*attr_interlocks_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	Name of the serial line
 */
	string	serial_line;
/**
 *	Flag to force reinitialisation (This is needed on certain old daresbury board)
 *	Default is 0 (no initialisation)
 */
	Tango::DevShort	init_pscom;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Daresbury(Tango::DeviceClass *,string &);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Daresbury(Tango::DeviceClass *,const char *);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	Daresbury(Tango::DeviceClass *,const char *,const char *);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~Daresbury() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name Daresbury methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values from hardware acquisition result.
 */
	virtual void read_attr(Tango::Attribute &attr);
/**
 * Reset the interlock system
 *	@exception DevFailed
 */
	void	reset();
/**
 * Return description of specified interlocks.
 *	
 *	argin[0] = Word address (Itlk 1)
 *	argin[1] = Bit address (Itlk 1)
 *	
 *	argin[2n] = Word address (itlk n)
 *	argin[2n+1] = Bit address (itlk n)
 *	
 *	argout[0] = Itlk description 1
 *	argout[n] = Itlk description n
 *	@param	argin	List of Interlock address [Word address , Bit address]*
 *	@return	Interlock descrition array
 *	@exception DevFailed
 */
	Tango::DevVarStringArray	*get_interlock_description(const Tango::DevVarLongArray *);
/**
 * Sets the descripton of the specified interlock
 *	@param	argin	argin[0]=Word address argin[1]=Bit address argin[2]=Interlock description
 *	@exception DevFailed
 */
	void	set_interlock_description(const Tango::DevVarStringArray *);
/**
 * Returns a list of known logs.
 *	@return	Return a list of interlock logs ,by date)
 *	@exception DevFailed
 */
	Tango::DevVarLongArray	*get_history_info();
/**
 * Returns the states of the interlock set of the specified log
 *	@param	argin	Log time , see GetHistoryInfo )
 *	@return	Array of interlock
 *	@exception DevFailed
 */
	Tango::DevVarShortArray	*read_interlock_history(Tango::DevLong);
/**
 * Returns a list of all description.
 *	@return	List of interlock description
 *	@exception DevFailed
 */
	Tango::DevVarStringArray	*get_all_description();
/**
 * Return the string read via the serial line on the controller. Debugging purpose.
 *	@return	Raw output of the Daresbury controller
 *	@exception DevFailed
 */
	Tango::DevString	read_serial();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	void  save_property(char *name,char *value);
	void  save_descriptions();
	void  save_description(int address,int bit);
	void  load_descriptions(int address);
	void  initialise_pscom();
        void  send_cmd(char *cmd, char **argout);
        void  write_cmd(char *cmd, char **argout);
	short compact_state(short state);
        void  msleep(int ms);
	long  get_ticks();
	
	Tango::DeviceProxy *theSerial;
	ItlkLog *logs;
	int      nb_log;
	long     start_time;
	char    *descriptions[MAX_MODS*8];

};

}	// namespace

#endif	// _DARESBURY_H
